from xml.dom import minidom
import nltk
from glob import glob
from os.path import basename
import unicodecsv
import string

exclude = set(string.punctuation)
def cleanTitle(title):
    title = title.lower().strip()
    title = ''.join(ch for ch in title if ch not in exclude)
    return title


### READS THE AUTHOR, YEAR AND PAPERID OF THE PAPER IN THE CORPUS
paper_data = {}
f = open("paper_author_title_year.csv","rb") 
rdr = unicodecsv.reader(f, encoding='ISO-8859-1')
for entry in rdr:
    title = entry[-2]
    title = cleanTitle(title)
    paper_data[title] = {}
    paper_data[title]["year"] = entry[-1]
    paper_data[title]["paperid"] = entry[0]
    paper_data[title]["authors"] = entry[1:-2]
f.close()

def getPaperId(title):
    try:
        d =  paper_data[title] #### THIS SEARCHES FOR EXACT MATCH OF THE PAPER TITLE. THIS CAN BE CHANGED SO THAT IT MAKES A FUZZY MATCH.
        return d["paperid"]
    except:
        #print "NOT FOUND: ", title
        return ""

def getAuthors(title):
    return paper_data[title]["authors"]

def getYear(title):
    return int(paper_data[title]["year"])



negwords = numpy.loadtxt("words_neg.txt", dtype="str")
poswords = numpy.loadtxt("words_pos.txt", dtype="str")

negregex = re.compile(r"\b({0})\b".format("|".join(negword for negword in negwords)))
posregex = re.compile(r"\b({0})\b".format("|".join(negword.replace("_"," ") for negword in poswords)))

poscount = 0
negcount = 0
othercount = 0

PATH = ## TO INSERT THE PATH TO ALL THE PARSCIT PARSED XML FILES
for f in glob(PATH):
    xmldoc = minidom.parse(f)
    paperId = basename(f)[:-4]
    print paperId

    itemlist = xmldoc.getElementsByTagName('citation') ## THIS GIVES THE LIST OF CITATIONS WITHIN THE PAPER

    for s in itemlist: 
        try:
            title = cleanTitle(s.getElementsByTagName("title")[0].firstChild.data)
            cited_paper_id = getPaperId(title) # GET THE PAPER ID FROM THE PAPER TITLE
            if cited_paper_id == "":
                continue
            print title, cited_paper_id
        except IndexError, KeyError:
            continue
        contexts = s.getElementsByTagName("context")

        relTxt = ""
        for context in contexts:
            citeStr = context.getAttribute("citStr")
            citeTxt = context.firstChild.data

            sents = nltk.sent_tokenize(citeTxt)
            correctSents = []
            ccent = ""
            addnext = False

            for sent in sents:
                if addnext:
                    ccent += " " + sent
                elif sent.strip()[0].islower() and not sent.strip()[0].isdigit():
                    ccent += " " + sent
                else:
                    correctSents.append(ccent)
                    ccent = sent
                addnext = False

                if sent.strip()[-3:] == "al.":
                    addnext = True
                elif sent.strip()[-4:] == "e.g.":
                    addnext = True
            if ccent !="":
                correctSents.append(ccent)

            for sent in correctSents:
                if sent.count(citeStr) > 0:
                    relTxt = relTxt + " " +sent

            relTxt = relTxt.lower() ####### THIS IS THE CITATION CONTEXT FOR ONE PARTICULAR CITATION


            # NOW THAT WE HAVE THE CITATION CONTEXT, WE NOW FIND WHETHER IT IS POSITIVE, NEGATIVE OR NEUTRAL
            isneg = 0
            ispos = 0
            words = []
            if re.findall(negregex, relTxt)!=[]:
                isneg += len(re.findall(negregex, relTxt))
                words.extend(re.findall(negregex, relTxt))
            if re.findall(posregex, relTxt)!=[]:
                ispos += len(re.findall(posregex, relTxt))
                words.extend(re.findall(posregex, relTxt))

            if isneg > 0 and ispos == 0:
                negcount += 1
                print paperId, cited_paper_id, "NEGATIVE", l
                ## NEGATIVE CITATION
            elif isneg == 0 and ispos > 0:
                poscount += 1
                print paperId, cited_paper_id, "POSITIVE", l
                ## POSITIVE CITATION
            else:
                othercount += 1
                print paperId, cited_paper_id, "NEUTRAL", l
                ## NEUTRAL CITATION

